import { Logger } from "@libp2p/logger";
import { Config, Effect, ModelValue, QueryParams } from "@canvas-js/modeldb";
import { Database } from "@sqlite.org/sqlite-wasm";
export declare class InnerModelDB {
    #private;
    readonly db: Database;
    protected readonly log: Logger;
    constructor(db: Database, config: Config, log: Logger);
    close(): void;
    apply(effects: Effect[]): void;
    get<T extends ModelValue>(modelName: string, key: string): T;
    iterate(modelName: string): AsyncIterable<ModelValue>;
    count(modelName: string): number;
    query<T extends ModelValue = ModelValue>(modelName: string, query?: QueryParams): T[];
}
