import { AbstractModelDB, Effect, ModelValue, ModelSchema, QueryParams } from "@canvas-js/modeldb";
import { Awaitable } from "@canvas-js/interfaces";
export interface ModelDBOptions {
    path: string;
    models: ModelSchema;
}
export declare class TransientModelDB extends AbstractModelDB {
    private readonly wrappedDB;
    private subscriptionId;
    static initialize({ models }: ModelDBOptions): Promise<TransientModelDB>;
    private constructor();
    close(): Promise<void>;
    apply(effects: Effect[]): Promise<void>;
    get<T extends ModelValue>(modelName: string, key: string): Promise<T | null>;
    iterate(modelName: string): AsyncIterable<ModelValue>;
    count(modelName: string): Promise<number>;
    query<T extends ModelValue = ModelValue>(modelName: string, query?: QueryParams): Promise<T[]>;
    subscribe<T extends ModelValue = ModelValue>(modelName: string, query: QueryParams, callback: (results: ModelValue[]) => Awaitable<void>): {
        id: number;
        results: Promise<T[]>;
    };
}
